<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\LastFoodRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\LastFood;

class LastFoodController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/lastfoods';
    /** View folder */
    private $viewDirectory= 'admin.lastfoods.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('lastfoods.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the lastfoods.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $ids = LastFood::pluck('user_id');
        $query = User::whereIn('id',$ids)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $lastfoods= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('lastfoods'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('lastfoods.store');
        $head = metaFields('lastfoods', 'add_new', getCurrentLocale()) ?? __('lastfoods.new');
$patients = User::where('role_id','6')->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param LastFoodRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(LastFoodRequest $request) :RedirectResponse
    {
     
         $this->saveData( $request, $request->user_id );

        
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  LastFood  $lastfood
     * @return View
     */
    public function edit(User $lastfood): View
    {
        $action= route('lastfoods.update', $lastfood->id);
        $head = metaFields('lastfoods', 'edit', getCurrentLocale()) ?? __('lastfoods.edit');
        $patients = User::where('role_id','6')->get();
        $lastfoods = LastFood::where('user_id',$lastfood->id)->get();
        
        return view( $this->viewDirectory.'form', compact('lastfood','lastfoods', 'action', 'head','patients') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  LastFoodRequest  $request
     * @param  LastFood  $lastfood
     * @return RedirectResponse|Redirector
     */
    public function update(LastFoodRequest $request, User $lastfood) :RedirectResponse
    {
         $lastfoods = LastFood::where('user_id',$lastfood->id)->delete();
         $this->saveData( $request, $request->user_id );
		
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
 private function saveData(Request $request, int $id ):void
    {
        
       if (!is_null($request->lastfood))
       {
           
            foreach ($request->lastfood as $row)
            {
                if(is_null($row['dating'])){
                    $date = date('Y-m-d');
                }
                else{
                    $date = $row['dating'];
                }
              LastFood::create([
            'user_id'=>$id,
            'dating'=>$date,
            'description'=>$row['description'],
            
                                            ]);





            
              
            }
        }

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = LastFood::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            LastFood::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            LastFood::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = LastFood::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = LastFood::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
